import { forwardRef } from 'react';
import PropTypes from 'prop-types';
import Injector from '@s-ui/react-primitive-injector';
import Poly from '@s-ui/react-primitive-polymorphic-element';
import AccordionItemHeaderIconDefault from './AccordionItemHeaderIconDefault.js';
import { BASE_CLASS_ITEM_HEADER_ICON } from './settings.js';
import { jsx as _jsx } from "react/jsx-runtime";
var AccordionItemHeaderIcon = /*#__PURE__*/forwardRef(function (_ref, forwardedRef) {
  var _ref$as = _ref.as,
    as = _ref$as === void 0 ? 'div' : _ref$as,
    _ref$children = _ref.children,
    children = _ref$children === void 0 ? /*#__PURE__*/_jsx(AccordionItemHeaderIconDefault, {}) : _ref$children,
    isExpanded = _ref.isExpanded,
    disabled = _ref.disabled,
    animationDuration = _ref.animationDuration;
  return /*#__PURE__*/_jsx(Poly, {
    as: as,
    ref: forwardedRef,
    className: BASE_CLASS_ITEM_HEADER_ICON,
    children: /*#__PURE__*/_jsx(Injector, {
      disabled: disabled,
      isExpanded: isExpanded,
      animationDuration: animationDuration,
      children: children
    })
  });
});
AccordionItemHeaderIcon.displayName = 'AccordionItemHeaderIcon';
AccordionItemHeaderIcon.propTypes = {
  /** The elementType of the wrapper **/
  as: PropTypes.elementType,
  /** The animation duration in ms **/
  animationDuration: PropTypes.number,
  /** child element **/
  children: PropTypes.node,
  /** element enabled or not **/
  disabled: PropTypes.bool,
  /** controlled expanded accordion item behavior */
  isExpanded: PropTypes.bool
};
export default AccordionItemHeaderIcon;