import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["children", "values", "defaultValues", "onChange", "behavior"];
import PropTypes from 'prop-types';
import useControlledState from '@s-ui/react-hooks/lib/useControlledState/index.js';
import { BEHAVIOR } from '../settings.js';
import AccordionContext, { defaultAccordionContext } from './index.js';
import { jsx as _jsx } from "react/jsx-runtime";
var AccordionProvider = function AccordionProvider(_ref) {
  var children = _ref.children,
    values = _ref.values,
    defaultValues = _ref.defaultValues,
    onChange = _ref.onChange,
    behavior = _ref.behavior,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  var _useControlledState = useControlledState(values, defaultValues),
    stateValues = _useControlledState[0],
    setStateValues = _useControlledState[1];
  return /*#__PURE__*/_jsx(AccordionContext.Provider, {
    value: _extends({}, defaultAccordionContext, props, {
      behavior: behavior,
      onChange: onChange,
      values: stateValues,
      setValues: setStateValues
    }),
    children: children
  });
};
AccordionProvider.displayName = 'AccordionProvider';
export default AccordionProvider;