import _extends from "@babel/runtime/helpers/esm/extends";
import { forwardRef } from 'react';
import { isFragment } from 'react-is';
import PropTypes from 'prop-types';
import Poly from '@s-ui/react-primitive-polymorphic-element';
import { AccordionProvider } from './context/index.js';
import AccordionItem from './AccordionItem.js';
import AccordionItemHeader from './AccordionItemHeader.js';
import AccordionItemHeaderIcon from './AccordionItemHeaderIcon.js';
import AccordionItemPanel from './AccordionItemPanel.js';
import { ANIMATION_DURATION, BASE_CLASS, BEHAVIOR, HEADER_ICON_POSITION, HEADER_LABEL_WRAPS, SPACING } from './settings.js';
import { jsx as _jsx } from "react/jsx-runtime";
var MoleculeAccordion = /*#__PURE__*/forwardRef(function (_ref, forwardedRef) {
  var _ref$as = _ref.as,
    As = _ref$as === void 0 ? 'div' : _ref$as,
    values = _ref.values,
    _ref$defaultValues = _ref.defaultValues,
    defaultValues = _ref$defaultValues === void 0 ? [] : _ref$defaultValues,
    onChange = _ref.onChange,
    behavior = _ref.behavior,
    children = _ref.children,
    _ref$animationDuratio = _ref.animationDuration,
    animationDuration = _ref$animationDuratio === void 0 ? ANIMATION_DURATION.NORMAL : _ref$animationDuratio,
    headerIconExpanded = _ref.headerIconExpanded,
    headerIconCollapsed = _ref.headerIconCollapsed,
    _ref$headerLabelWrap = _ref.headerLabelWrap,
    headerLabelWrap = _ref$headerLabelWrap === void 0 ? HEADER_LABEL_WRAPS.NO_WRAP : _ref$headerLabelWrap,
    _ref$headerIconPositi = _ref.headerIconPosition,
    headerIconPosition = _ref$headerIconPositi === void 0 ? HEADER_ICON_POSITION.RIGHT : _ref$headerIconPositi,
    _ref$maxHeight = _ref.maxHeight,
    maxHeight = _ref$maxHeight === void 0 ? 0 : _ref$maxHeight;
  return /*#__PURE__*/_jsx(Poly, _extends({
    as: As
  }, !isFragment( /*#__PURE__*/_jsx(As, {})) && {
    ref: forwardedRef,
    className: BASE_CLASS
  }, {
    children: /*#__PURE__*/_jsx(AccordionProvider, {
      values: values,
      defaultValues: defaultValues,
      onChange: onChange,
      behavior: behavior,
      animationDuration: animationDuration,
      headerIconExpanded: headerIconExpanded,
      headerIconCollapsed: headerIconCollapsed,
      headerIconPosition: headerIconPosition,
      headerLabelWrap: headerLabelWrap,
      maxHeight: maxHeight,
      children: children
    })
  }));
});
MoleculeAccordion.displayName = 'MoleculeAccordion';
export { MoleculeAccordion, AccordionItem as MoleculeAccordionItem, AccordionItemHeader as MoleculeAccordionItemHeader, AccordionItemHeaderIcon as MoleculeAccordionItemHeaderIcon, AccordionItemPanel as MoleculeAccordionItemPanel, BEHAVIOR as moleculeAccordionBehavior, ANIMATION_DURATION as moleculeAccordionAnimationDuration, HEADER_ICON_POSITION as moleculeAccordionHeaderIconPosition, HEADER_LABEL_WRAPS as moleculeAccordionHeaderLabelWraps };
export default MoleculeAccordion;